diff --git a/changelog b/changelog
index c9a8e1a..c15d753 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,4 @@
+20080109 tpd src/doc/book add Ei,En,Ei1,Ei2,Ei3,Ei4,Ei5,Ei6
 20080107 tpd Makefile fix GCLOPTS-CUSTRELOC for macosxppc
 20080107 tpd Makefile add Makefile.macosxppc stanza and GCLOPTS-CUSTRELOC
 20080107 tpd src/algebra/Makefile make cp of upper/lower files conditional
diff --git a/src/doc/book.pamphlet b/src/doc/book.pamphlet
index 377d5c6..4fdb58c 100644
--- a/src/doc/book.pamphlet
+++ b/src/doc/book.pamphlet
@@ -17252,7 +17252,7 @@ $z=3$:
 %\epsffile[0 0 295 295]{ps/newmap.ps}
 
 % I think this is good to say here: it shows a lot of depth. RSS
-{\sloppy
+%{\sloppy
 The {\tt CoordinateSystems} package exports the following
 \index{coordinate system}
 operations:
@@ -18231,12 +18231,12 @@ $Gamma(z)$ is the Euler gamma function,
 {\bf Beta}: $F -> F$\hfill\newline
    $Beta(u, v)$ is the Euler Beta function,
 \index{function!Euler Beta}
-   $B(u,v)$, defined by
+   $Beta(u,v)$, defined by
 \index{Euler!Beta function}
-   $$B(u,v) = \int_{0}^{1} t^{u-1} (1-t)^{v-1} dt.$$
+   $$Beta(u,v) = \int_{0}^{1} t^{u-1} (1-t)^{v-1} dt.$$
    
    This is related to $\Gamma(z)$ by
-   $$B(u,v) = \frac{\Gamma(u) \Gamma(v)}{\Gamma(u + v)}.$$
+   $$Beta(u,v) = \frac{\Gamma(u) \Gamma(v)}{\Gamma(u + v)}.$$
 
 \noindent
 {\bf logGamma}: $F -> F$\hfill\newline
@@ -18261,6 +18261,63 @@ is the function $\psi(z)$,
    $\psi(z)$, written $\psi^{(n)}(z)$.
 
 \noindent
+{\bf E1}: $(DoubleFloat) -> OnePointCompletion DoubleFloat$\hfill\newline
+   E1(x) is the Exponential Integral function
+   The current implementation is a piecewise approximation
+   involving one poly from $-4..4$ and a second poly for $x > 4$
+\index{function!E1}
+
+\noindent
+{\bf En}: $(PI, DFLOAT) -> OnePointCompletion DoubleFloat$\hfill\newline
+   En(PI,R) is the nth Exponential Integral
+\index{function!En}
+
+\noindent
+{\bf Ei}: $(OnePointCompletion DFLOAT) -> OnePointCompletion DFLOAT$
+\hfill\newline
+   Ei is the Exponential Integral function
+   This is computed using a 6 part piecewise approximation.
+   DoubleFloat can only preserve about 16 digits but the
+   Chebyshev approximation used can give 30 digits.
+\index{function!Ei}
+
+\noindent
+{\bf Ei1}: $(DoubleFloat) -> DoubleFloat$\hfill\newline
+   Ei1 is the first approximation of Ei where the result is
+   $x*e^-x*Ei(x)$ from -infinity to -10 (preserves digits)
+\index{function!Ei1}
+
+\noindent
+{\bf Ei2}: $(DoubleFloat) -> DoubleFloat$\hfill\newline
+   Ei2 is the first approximation of Ei where the result is
+   $x*e^-x*Ei(x)$ from -10 to -4 (preserves digits)
+\index{function!Ei2}
+
+\noindent
+{\bf Ei3}: $(DoubleFloat) -> DoubleFloat$\hfill\newline
+   Ei3 is the first approximation of Ei where the result is
+   $(Ei(x)-log |x| - gamma)/x$ from -4 to 4 (preserves digits)
+\index{function!Ei3}
+
+\noindent
+{\bf Ei4}: $(DoubleFloat) -> DoubleFloat$\hfill\newline
+   Ei4 is the first approximation of Ei where the result is
+   $x*e^-x*Ei(x)$ from 4 to 12 (preserves digits)
+\index{function!Ei4}
+
+\noindent
+{\bf Ei5}: $(DoubleFloat) -> DoubleFloat$\hfill\newline
+   Ei5 is the first approximation of Ei where the result is
+   $x*e^-x*Ei(x)$ from 12 to 32 (preserves digits)
+\index{function!Ei5}
+
+\noindent
+{\bf Ei6}: $(DoubleFloat) -> DoubleFloat$\hfill\newline
+   Ei6 is the first approximation of Ei where the result is
+   $x*e^-x*Ei(x)$ from 32 to infinity (preserves digits)
+\index{function!Ei6}
+
+\noindent
 {\bf besselJ}: $(F,F) -> F$\hfill\newline
    $besselJ(v,z)$ is the Bessel function of the first kind,
 \index{function!Bessel}
